﻿using Prism.Ioc;
using WolfOfWallStreet.Views;
using System.Windows;
using WolfOfWallStreet.Services;
using WolfOfWallStreet.Services.Contracts;
using WolfOfWallStreet.ViewModels;
using WolfOfWallStreet.Views.Controllers;

namespace WolfOfWallStreet
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App
    {
        protected override Window CreateShell()
        {
            return Container.Resolve<MainWindow>();
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterForNavigation<MainPage,MainPageViewModel>();
            containerRegistry.RegisterForNavigation<OnlinePlusController,OnlinePlusControllerViewModel>();
            containerRegistry.RegisterForNavigation<SymbolsController,SymbolsControllerViewModel>();
            containerRegistry.RegisterForNavigation<EasyTraderController,EasyTraderControllerViewModel>();
            containerRegistry.RegisterForNavigation<MofidOnlineController,MofidOnlineControllerViewModel>();
            containerRegistry.Register<SettingsServices>();
            containerRegistry.Register<IEasyTraderService, EasyTraderService>();
            containerRegistry.Register<IMofidOnlineService, MofidOnlineService>();
            containerRegistry.Register<IOnlinePlusService, OnlinePlusService>();
        }
    }
}
