﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WolfOfWallStreet.Models;
using WolfOfWallStreet.Properties;

namespace WolfOfWallStreet.Services
{
    public class SettingsServices
    {
        public SettingsServices()
        {
            List<Symbol> Symbols = new List<Symbol>();
            try
            {
                Symbols = Newtonsoft.Json.JsonConvert.DeserializeObject<List<Symbol>>(Settings.Default.Symbols);
                if(Symbols==null)
                    Symbols = new List<Symbol>();
                
            }
            catch (Exception e)
            {
                Symbols = new List<Symbol>();
            }

            if (Symbols.Count == 0)
            {
                Symbols.Add(new Symbol
                {
                    SymbolName = "سیتا",
                    symbolISIN = "IRO1SITA0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "آریا",
                    symbolISIN = "IRO3APOZ0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "پیزد",
                    symbolISIN = "IRO3YZTZ0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "آبادا",
                    symbolISIN = "IRO1NBAB0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "شتران",
                    symbolISIN = "IRO1PTEH0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "های وب",
                    symbolISIN = "IRO1HWEB0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "خگستر",
                    symbolISIN = "IRO1GOST0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "شگویا",
                    symbolISIN = "IRO3TPEZ0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "ولپارس",
                    symbolISIN = "IRO1LPRS0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "ونیکی",
                    symbolISIN = "IRO1NIKI0001"
                });
                Symbols.Add(new Symbol
                {
                    SymbolName = "شستا",
                    symbolISIN = "IRO1TAMN0001"
                });
                Settings.Default.Symbols = Newtonsoft.Json.JsonConvert.SerializeObject(Symbols);
                Properties.Settings.Default.Save();
            }
        }
        public List<Symbol> GetSymbols()
        {
            try
            {

                var symbols = Newtonsoft.Json.JsonConvert.DeserializeObject<List<Symbol>>(Settings.Default.Symbols);
                return symbols;
            }
            catch (Exception e)
            {
                return new List<Symbol>();
            }
        }

        public void AddSymbol(Symbol symbol)
        {
            try
            {

                var symbols = Newtonsoft.Json.JsonConvert.DeserializeObject<List<Symbol>>(Settings.Default.Symbols);
                symbols.Add(symbol);
                Settings.Default.Symbols = Newtonsoft.Json.JsonConvert.SerializeObject(symbols);
                Properties.Settings.Default.Save();
            }
            catch (Exception e)
            {
                var symbols = new List<Symbol>();
                symbols.Add(symbol);
                Settings.Default.Symbols = Newtonsoft.Json.JsonConvert.SerializeObject(symbols);
                Properties.Settings.Default.Save();
            }
            
        }

        public void RemoveSymbol(Symbol symbol)
        {
            try
            {

                var symbols = Newtonsoft.Json.JsonConvert.DeserializeObject<List<Symbol>>(Settings.Default.Symbols);
                symbols.Remove(symbols.FirstOrDefault(s=>s.symbolISIN==symbol.symbolISIN));
                Settings.Default.Symbols = Newtonsoft.Json.JsonConvert.SerializeObject(symbols);
                Properties.Settings.Default.Save();
            }
            catch (Exception e)
            {

            }
        }
    }
}
