﻿using System;
using System.Collections.Generic;
using System.Text;
using Prism.Mvvm;
using Prism.Regions;
using Prism.Services.Dialogs;

namespace WolfOfWallStreet.ViewModels
{

    public class ViewModelBase : BindableBase
    {
        private string _title;
        public string Title
        {
            get { return _title; }
            set { SetProperty(ref _title, value); }
        }
        public IRegionManager RegionManager { get; }
        public ViewModelBase()
        {
            Initialize();
            InitialCommand();
        }
        public ViewModelBase(IRegionManager regionManager)
        {
            RegionManager = regionManager;
            Initialize();
            InitialCommand();
        }
        public virtual void InitialCommand()
        {

        }

        public virtual void Initialize()
        {

        }
    }
}
